"""s_goner.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains what happens when a lemming runs out of time.
"""

import globals as g
from excepts import *

attrs = {"isDeathAction": True, "isOnGround": False, "mustStartOnGround": False, "propertyChangeOnly": False }
frames = {1:[[],None]}

def update(lemming):
    if lemming.currentFrame == lemming.frameCount:
        lemming.setSkill("s_exploder", ignoreDeathAction=True)
        return
    else:
        try:    
            if not(lemming.checkPos((lemming.posX, lemming.posY+1), "ground")):
                if not (lemming.checkPos((lemming.posX, lemming.posY+2), "ground")):
                    if not (lemming.checkPos((lemming.posX, lemming.posY+3), "ground")):
                        if (lemming.checkPos((lemming.posX, lemming.posY+4), "ground")):
                            lemming.posY += 3
                        else:
                            lemming.posY += 3
                    else: 
                        lemming.posY += 2
                else: 
                    lemming.posY += 1
        except OutOfThePlayfield:
            lemming.kill()

    lemming._incAnimFrame()
    return

def set(lemming):
    if not g.skillCache.check(lemming.currentSkill, "isOnGround"):
        lemming.setSkill("s_exploder", ignoreDeathAction=True)
        return  
    lemming.currentSkill = "s_goner"
    lemming.currentFrame = 0
    lemming.rect.left = frames[1][1].left
    lemming.rect.right = frames[1][1].right
    lemming.rect.width = frames[1][1].width
    lemming.rect.height = frames[1][1].height
    lemming.frameCount = len(frames[1][0])
    lemming._incAnimFrame()
    return
